
Option Explicit     ' All variables must be declared using the 'Dim' statement
Scripting.DontExit = True ' Hang around to listen to events

Dim app
Dim doc

' Get the application object.  To run the script out-of-process, use GetObject.
Set app = Application

' Get the active document
Set doc = app.ActiveDocument

' License the document
If (ValidateServer(doc) = 1) Then
    
    ' add a reference to the MGCPCB type library in order to use enums
    Scripting.AddTypeLibrary("MGCPCB.CellEditorApplication")
	
	run

End If

Sub run()
	
	dim ul
	dim ulgs
	dim ulg, ulg2
	dim ptary
	dim x, y, r, x1, y1, h, d
	dim ary()
	dim geom
	dim pts
	dim ppts
	dim a, a2
	dim n
	dim sides
	Dim pi
	Dim pos
	Dim po
	Dim ptarys
	
	
	pi = 4 * Atn(1)
	
	sides = inputbox("How many sides do you want?")
	pts = sides + 1
	a = 360 / sides
	a2 = a / 2
	
	'convert degrees to radians
	a2 = (a2 * pi) / 180
	
	
	
	set ulgs = doc.userlayergfxs(1)
	if ulgs.count > 0 Then
		for each ulg in ulgs
			set ul = ulg.userlayer
			
			set geom = ulg.geometry
			if geom.iscircle = true Then
				r = geom.circleR
				ppts = get_polygon_pointsarray(sides, r, a2, a)
				doc.putuserlayergfx ul, 0, pts, ppts, False, Nothing, 0
			end if
		next
	end if
	
	set pos = doc.placementoutlines(1)
	if pos.count > 0 Then
		for each po in pos
			set geom = po.geometry
			if geom.iscircle = true Then
				r = geom.circleR
				ppts = get_polygon_pointsarray(sides, r, a2, a)
				doc.PutPlacementOutline 513, pts, ppts, 0.0, 0.0, Nothing, 0
			end if
		next
	end if
	
	
	
	
	
	
End Sub

Function get_polygon_pointsarray(sides, r, a2, a)
	dim ppts
	dim d
	dim x
	dim y
	dim n
	dim x1
	
	redim ppts(2, sides)
	
	d = r * tan(a2)
				
	x = d
	y = -r
	
	ppts(0, 0) = x
	ppts(1, 0) = y
	ppts(2, 0) = 0
	for n = 1 to sides
		x1 = x
		x = get_rotated_x_coordinate(x, y, a)
		y = get_rotated_y_coordinate(x1, y, a)
		ppts(0, n) = x
		ppts(1, n) = y
		ppts(2, n) = 0
	next
	
	get_polygon_pointsarray = ppts

End Function


Function get_rotated_x_coordinate(x, y, r)
	Dim x1, y1
	Dim r1
	Dim pi
	
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	x1 = (x * Cos(r1)) - (y * Sin(r1))
	
	get_rotated_x_coordinate = x1
End Function

Function get_rotated_y_coordinate(x, y, r)
	Dim x1, y1
	Dim r1
	Dim pi
	
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	y1 = (x * Sin(r1)) + (y * Cos(r1))
	
	get_rotated_y_coordinate = y1
End Function

Private Function ValidateServer(doc)
    
    Dim key, licenseServer, licenseToken

    ' Ask Expeditions document for the key
    key = doc.Validate(0)

    ' Get license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")

    ' Ask the license server for the license token
    licenseToken = licenseServer.GetToken(key)

    ' Release license server
    Set licenseServer = nothing

    ' Turn off error messages.  Validate may fail if the token is incorrect
    On Error Resume Next
    Err.Clear

    ' Ask the document to validate the license token
    doc.Validate(licenseToken)
    If Err Then
        ValidateServer = 0    
    Else
        ValidateServer = 1
    End If

End Function

