Option explicit
dim app
dim doc
dim gui

Set app = Application
Set doc = app.ActiveDocument

' License the document
If (ValidateServer(doc) = 1) Then
    Scripting.AddTypeLibrary("MGCPCB.CellEditorApplication")
End If


If not doc is nothing then
	set gui = app.gui
	gui.activemode = 0
End if

Set app = Nothing
Set doc = Nothing

Private Function ValidateServer(doc)
    
    Dim key, licenseServer, licenseToken

    ' Ask Expeditions document for the key
    key = doc.Validate(0)

    ' Get license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")

    ' Ask the license server for the license token
    licenseToken = licenseServer.GetToken(key)

    ' Release license server
    Set licenseServer = nothing

    ' Turn off error messages.  Validate may fail if the token is incorrect
    On Error Resume Next
    Err.Clear

    ' Ask the document to validate the license token
    doc.Validate(licenseToken)
    If Err Then
        ValidateServer = 0    
    Else
        ValidateServer = 1
    End If

End Function
