Option explicit

dim app
dim doc
dim gui
dim shell
dim regkey
dim local_app_data
dim idx
dim fso
dim file
dim tmp
dim ary
dim prog_id
dim vias
dim via
dim comps
dim comp
dim ulgs
dim ulg
dim extc
dim extu





get_id()

'Hook to Expedition
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
'Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)

set gui = app.gui

run


sub run

dim x1, x2
dim y1, y2
dim pos
dim po


	if doc.transactionstart(0) = True Then

		set comps = doc.components(1)
		set ulgs = doc.userlayergfxs(1)
		
		if comps.count > 1 then 
		
			msgbox "Select 1 component only.  You have too many components selected. "
			exit sub
			
		end if
		
		if ulgs.count > 1 then 
		
			msgbox "Select 1 userlayer polygon only.  You have too many selected. "
			exit sub
			
		end if
		
		for each comp in comps
			set pos = comp.placementoutlines
			for each po in pos
				exit for
			next
			set extc = po.extrema
			
			for each ulg in ulgs
				exit for
			next
			
			set extu = ulg.extrema
			
			x1 = (extc.maxx + extc.minx) / 2
			y1 = (extc.maxy + extc.miny) / 2
			x2 = (extu.maxx + extu.minx) / 2
			y2 = (extu.maxy + extu.miny) / 2
			
			'msgbox "x2: " & x2 & vbtab & "y2: " & y2
			comp.moverelative x2 - x1, y2 - y1
		
		next
		
		

		doc.transactionend(true)
	end if



	Set app = Nothing
	Set doc = Nothing
end sub





Public Sub get_id()
	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub















'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
