'Acceptable Usage Policy
'
'  This software is NOT officially supported by Mentor Graphics.
'
'  ####################################################################
'  ####################################################################
'  ## The following  software  is  "freeware" which  Mentor Graphics ##
'  ## Corporation  provides as a courtesy  to our users.  "freeware" ##
'  ## is provided  "as is" and  Mentor  Graphics makes no warranties ##
'  ## with  respect  to "freeware",  either  expressed  or  implied, ##
'  ## including any implied warranties of merchantability or fitness ##
'  ## for a particular purpose.                                      ##
'  ####################################################################
'  ####################################################################
'
'==========================================================================
'
' NAME: LayerStackup.vbs
' DESCRIPTION: Gemerates stackup graphics into Expedition PCB or Fablink XE
'
' AUTHOR: Mike Lowder, Mentor Graphics
' DATE  : 2006 August 11
'
'        2006 Mentor Graphics Corporation
'       All Rights Reserved
'
'
'   THIS WORK CONTAINS TRADE SECRET AND PROPRIETARY
'   INFORMATION WHICH IS THE PROPERTY OF MENTOR
'   GRAPHICS CORPORATION OR ITS LICENSORS AND Is
'   SUBJECT TO LICENSE TERMS. 
'==========================================================================

Option Explicit     ' All variables must be declared using the 'Dim' statement
Scripting.DontExit = True ' Hang around to listen to events

'---------------------------------------
'Begin Main program
'---------------------------------------
' The units of all the constants below are in mils
Dim dielectricBoxX		'width of the box for the dielectric layers
Dim dielectricBoxY		'height of the box for the dielectric layers
Dim traceBoxX				'width of the box for trace layers (two each layer)
Dim traceBoxY				'height of the box for trace layers
Dim traceBox1OffsetX		'start position of first trace box
Dim traceBox2OffsetX		'start position of second trace box
Dim planeBoxX				'width of the box for plane layers
Dim planeBoxY				'height of the box for plane layers
Dim textOffsetX			'X offset for text for each layer
Dim textOffsetYdie		'Y offset for text for dielectric layer
Dim textOffsetYsm			'Y offset for text for solder mask layer
Dim textOffsetYcond		'Y offset for text for conductive layers
Dim textHeight			'height of text
Dim userLayerName		'userlayer for the stackup graphics
Dim stepCondY				'spacing above conductive layer
Dim stepDieY				'spacing above dielectric layer
Dim stepTitleY			'spacing in title area
dim stepY				'Y spacing between all layers
Dim titleTextOffestX		'start position of title text
Dim sm_box				'height of the box for soldermask layers
Dim rnd_val				'number of places to round decimal values

'variables used to draw the overall dimension lines and text
Dim dy1		'the bottom of the dimension line
Dim dy2		'the top end of the bottom line
Dim dy3		'the bottom end of the top line
Dim dy4		'the top of the dimension line
Dim dx		'the x location of the dimension
dim xw		'
dim dtxty	'the y location of the dimension text
dim dimbarwidth		'half the width of the dimension crossbars
dim dimoffsetx		'offset (to the left of the layer boxes) of the dimension line
dim dimlinewidth	'linewidth of the dimension lines
dim dimarrowlength	'dimension arrow length
dim	dimarrowwidth	'dimension arrow width
dim dimgap			'gap between layer box and dimension bar

Dim colorPatternObj
Dim currentCondLayer
Dim currentDieLayer
Dim cUsrLyrGrfx, cUsrLyrTxts
Dim dontexit
Dim GetPointCmd
Dim i
Dim lyrObj
Dim lyrObjColl
Dim numOfPnts : numOfPnts = 5     ' 5 points for a rectangle
Dim pcbApp
Dim pcbDoc
Dim pntsArr
Dim rectObj
Dim lineObj
dim arrowObj
Dim textStr
Dim totalThickness : totalThickness = 0
Dim converted_totalThickness
Dim units
Dim usrLyrObj
Dim globalDisplayControl
Dim tagMotion : tagMotion = -1
dim font
dim unit_str
dim thk 		'thickness of a layer object

dim cu
dim cu2
dim tmp
dim cu_string

userLayerName = inputbox("What UserLayer do you want to place the Stackup graphis on")





' below are variables for the current X and Y coordinates for where we are going 
' to draw the boxes for the stackup and text. Most likely the X coordinates will
' not change since we are just going to up to draw the next box. For this example
' the origin of 0, 0 will be used as the starting X and Y coordinates.
Dim curX : curX = 0   
Dim curY : curY = 0   

' Get the application object.  To run the script out-of-process, use GetObject.
'Set pcbApp = GetObject(,"MGCPCB.ExpeditionPCBApplication")
Set pcbApp = Application

' Get the active document
Set pcbDoc = pcbApp.ActiveDocument

' License the document
If (ValidateServer(pcbDoc) = 1) Then


    
    ' add a reference to the MGCPCB type library in order to use enums
    Scripting.AddTypeLibrary("MGCPCB.ExpeditionPCBApplication")
	
	cu = pcbDoc.currentunit
	Select Case cu
		Case 2
			cu_string = "th"
		Case 3 
			cu_string = "in"
		Case 4
			cu_string = "mm"
		Case 5
			cu_string = "um"
	End Select
	
	cu_string = "Current design unit is " & cu_string
	
	tmp = "What units do you want to use?" & vbcrlf & vbCrlf
	tmp = tmp & cu_string & vbcrlf & vbcrlf
	tmp = tmp & "2: mils" & vbCrlf
	tmp = tmp & "3: inches" & vbCrlf
	tmp = tmp & "4: mm" & vbCrlf
	tmp = tmp & "5: um"
	
	cu2 = inputbox(tmp)
	
	pcbDoc.currentunit = cu2
	
	Call set_units()
    'units = pcbDoc.currentunit
	units = cu2
	
	font = "Arial"
	
	select case pcbDoc.currentunit
		Case 2
			unit_str = "mil"
			rnd_val = 2
		Case 3
			unit_str = "in"
			rnd_val = 4
		Case 4
			unit_str = "mm"
			rnd_val = 3
		Case 5
			unit_str = "um"
			rnd_val = 0
	End Select
    
    ' register a cmd so we can get a mouse point
    Set GetPointCmd = pcbApp.Gui.RegisterCommand("GetPoint")
    
    ' attach the events to the command
    Scripting.AttachEvents GetPointCmd, "getpntcmd"
	Call DrawMotionGraphics(pcbDoc.ActiveView.MousePositionX, pcbDoc.ActiveView.MousePositionY)
    
    ' set the prompt field in the status bar
    pcbApp.Gui.StatusBarText "Enter point for lower left corner of stackup...", _
    	epcbStatusFieldPrompt
		
	pcbDoc.currentunit = cu	
    	
Else
    Msgbox("Could not validate the server. Exiting program.")
End If
'---------------------------------------
'End Main program
'---------------------------------------

'---------------------------------------
'Add local functions, subroutines,
'and methods here
'---------------------------------------

'---------------------------------------
'Local functions
'---------------------------------------
Function GenerateStackupGraphicsOnUserLayer(x, y)
    curX = x
    curY = y
	If ConfigureUserLayer = false then
		Exit Function
	End If

    ' start the transaction
    pcbDoc.TransactionStart
    
    totalThickness = 0.0
	
    Call GenerateStackupGraphics(usrLyrObj, curX, curY)
    
    ' clear the prompt field in the status bar
    Call pcbApp.Gui.StatusBarText("", epcbStatusFieldPrompt)

    ' end the transaction
    pcbDoc.TransactionEnd
End Function 

Function GenerateStackupGraphics(usrLyrObj, x, y)

    curX = x
    curY = y
	
	' now we need to add the header text
    textstr = "9"
	Call DrawText(usrLyrObj, textstr, curX + titleTextOffestX / 2, curY, units)
	
	textstr = "LAYER STACKUP DETAIL"
	Call DrawText(usrLyrObj, textstr, curX + titleTextOffestX, curY, units)
	
	' step the Y position
    curY = curY + stepTitleY

    ' set the conductive and dielectric layer counts
    currentCondLayer = pcbDoc.LayerCount
    currentDieLayer = currentCondLayer + 1
        
    ' get the layer objects collection
    Set lyrObjColl = pcbDoc.LayerStack(True)
    
    ' since we are starting at the bottom and working our way up
    ' loop through the collection backward in a for loop
    For i = lyrObjColl.Count to 1 Step -1
        ' clear the text string for this layer
        textStr = ""
		
		'set dy1 and dy2, the ends of the dimension line
		Select Case i
			Case 1
				dy2 = curY + sm_box / 2
			Case lyrObjColl.Count
				dy1 = curY - sm_box / 2
		End Select
        
        ' get the layer object from the collection
        Set lyrObj = lyrObjColl.Item(i)
		
		thk = lyrObj.LayerProperties.Thickness(units)
		thk = round(thk, rnd_val)
        
        ' set the text string
		Select Case i
			Case 1
				textStr = "     " & thk & " " & unit_str &  ", Solder Mask Top"
			Case lyrObjColl.Count
				textStr = "     " & thk & " " & unit_str &  ", Solder Mask Bottom"
			Case else
				textStr = "     " & thk & " " & unit_str & ", " & lyrObj.LayerProperties.Description
		End Select
        
        
        ' add the layer thickness to the total
        totalThickness = totalThickness + thk
		
        
        ' if this a dielectric layer then draw its layer and text
        If lyrObj.Type = epcbLayerTypeInsulation Then
        
			Select Case i
				Case 1
					Call DrawSolderMaskLayer(lyrObj, usrLyrObj,curX, curY, units, textStr)
				
				Case lyrObjColl.Count
					Call DrawSolderMaskLayer(lyrObj, usrLyrObj,curX, curY, units, textStr)
				
				Case else
					Call DrawDielectricLayer(lyrObj, usrLyrObj,curX, curY, units, textStr)
			End Select
        	
            ' decrement the layer counter
            currentDieLayer = currentDieLayer - 1
            
        ' if this is a conductive layer then draw is layer and text
        ElseIf lyrObj.Type = epcbLayerTypeConductor Then            
            
			' if its a signal layer then draw two small boxes
            If lyrObj.ConductorType = epcbConductorTypeSignal Then
        		Call DrawSignalLayer(lyrObj, usrLyrObj, curX, curY, units)                
            
			' if its a plane layer then draw one rectangle
			ElseIf lyrObj.ConductorType = epcbConductorTypePlane Then
        		Call DrawPlaneLayer(lyrObj, usrLyrObj, curX, curY, units)
            
			
			End If

            ' decrement the layer counter
            currentCondLayer = currentCondLayer - 1
            
        End If
		
		' step the Y position
		curY = curY + stepY
		
    Next
	
	dx = curX - dimoffsetx
	dy3 = dy1 + ((dy2 - dy1) / 2) - stepCondY * .5
	dy4 = dy3 + stepCondY * 2 * .5
	
	converted_totalThickness = totalThickness
	
	
	Select Case pcbDoc.CurrentUnit
		Case 2
			'multiply by .001
			converted_totalThickness = converted_totalThickness * .001
			converted_totalThickness = round(converted_totalThickness, 3)
		Case 3
			'do nothing - units of inches are standard
			converted_totalThickness = round(converted_totalThickness, 3)
		Case 4
			'do nothing - drawing units of mm require no change
			converted_totalThickness = round(converted_totalThickness, 2)
		Case 5
			'do nothing - this never happens.  I mean, it might, but it probably won't. Fix the script if it does. 
			converted_totalThickness = round(converted_totalThickness, 0)
	End Select
	
	'DrawLine(objUserLayer, originX, originY, endX, endY, units)
	Call DrawLine(usrLyrObj, dx - dimbarwidth, dy1, curX - dimgap, dy1, units)
	Call DrawLine(usrLyrObj, dx, dy1 + dimarrowlength / 2, dx, dy3, units)
	Call DrawArrow(usrLyrObj, dx, dy1, 270, units)
	textstr = converted_totalThickness & " +/- 10%"
	Call DrawTextCentered(usrLyrObj, textstr, dx, (dy2 + dy1) / 2, units)
	Call DrawLine(usrLyrObj, dx, dy4, dx, dy2 - dimarrowlength / 2, units)
	Call DrawArrow(usrLyrObj, dx, dy2, 90, units)
	Call DrawLine(usrLyrObj, dx - dimbarwidth, dy2, curX - dimgap, dy2, units)
	
	
	
	
	

End Function

Function ConfigureUserLayer()
    
    Set usrLyrObj = pcbDoc.FindUserLayer(userLayerName)
    
    ' if the layer doesn't exist, create it, else delete all the data off the layer
    If usrLyrObj Is Nothing Then
        ' push the output mask to a user layer; create a user layer
		
		Dim tmp
		tmp = "The UserLayer " & userLayerName & " you specified is not a valid layer. "
		
		msgbox tmp
		
		ConfigureUserLayer = false
	else
		
		' ensure the user layer is turned on
		pcbDoc.ActiveView.DisplayControl.UserLayer(userLayerName) = True
		ConfigureUserLayer = true
		
    End If

    
    

End Function



Function DrawDielectricLayer(objLayer, objUserLayer, originX, originY, units, text_string)
	Call DrawRectangle(objUserLayer, originX, originY, dielectricBoxX, dielectricBoxY, False, units)
	Call DrawText(objUserLayer, text_string, originX + textOffsetX, originY, units)
End Function

Function DrawSolderMaskLayer(objLayer, objUserLayer, originX, originY, units, text_string)
	Call DrawRectangle(objUserLayer, originX, originY, dielectricBoxX, sm_box, False, units)
	Call DrawText(objUserLayer, text_string, originX + textOffsetX, originY, units)
End Function

Function DrawSignalLayer(objLayer, objUserLayer, originX, originY, units)
	Call DrawRectangle(objUserLayer, originX + traceBox1OffsetX, originY, traceBoxX, traceBoxY, True, units)
	Call DrawRectangle(objUserLayer, originX + traceBox2OffsetX, originY, traceBoxX, traceBoxY, True, units)
	Call DrawText(objUserLayer, GetLayerDescription(objLayer), originX + textOffsetX, originY, units)
End Function

Function DrawPlaneLayer(objLayer, objUserLayer, originX, originY, units)
	Call DrawRectangle(objUserLayer, originX, originY, planeBoxX, planeBoxY, True, units)
	Call DrawText(objUserLayer, GetLayerDescription(objLayer), originX + textOffsetX, originY + textOffsetYcond, units)
End Function

Function GetLayerDescription(objLayer)
		dim thk
		thk = objLayer.LayerProperties.Thickness(units)
		thk = round(thk, rnd_val)
        GetLayerDescription = thk & " " & unit_str & ", " & _
        	objLayer.LayerProperties.Description
End Function

Function DrawText(objUserLayer, strText, originX, originY, units)
	' If the user layer passed in is Nothing, then draw motion graphics
	If objUserLayer Is Nothing Then
		Call pcbDoc.ActiveView.MotionGfxPutText(strText, _
                                     originX, _
                                     originY, _
                                     epcbMotionGfxPointMoveXY, _
                                     textHeight,  _
                                     0, _
                                     5, _
                                     font, 0, _
                                     epcbJustifyLeft, _
                                     epcbJustifyVCenter, _
                                     tagMotion, _
                                     Nothing, _
                                     True, _
                                     units, epcbAngleUnitDegrees)
	Else
		Call pcbDoc.PutUserLayerText(strText, _
                                     originX, _
                                     originY, _
                                     objUserLayer, _
                                     textHeight,  _
                                     0, _
                                     5, _
                                     font, , _
                                     epcbJustifyLeft, _
                                     epcbJustifyVCenter, _
                                     Nothing, _
                                     units)
    End If
End Function

Function DrawTextCentered(objUserLayer, strText, originX, originY, units)
	' If the user layer passed in is Nothing, then draw motion graphics
	If objUserLayer Is Nothing Then
		Call pcbDoc.ActiveView.MotionGfxPutText(strText, _
                                     originX, _
                                     originY, _
                                     epcbMotionGfxPointMoveXY, _
                                     textHeight,  _
                                     0, _
                                     5, _
                                     font, 0, _
                                     epcbJustifyHCenter, _
                                     epcbJustifyVCenter, _
                                     tagMotion, _
                                     Nothing, _
                                     True, _
                                     units, epcbAngleUnitDegrees)
	Else
		Call pcbDoc.PutUserLayerText(strText, _
                                     originX, _
                                     originY, _
                                     objUserLayer, _
                                     textHeight,  _
                                     0, _
                                     5, _
                                     font, , _
                                     epcbJustifyHCenter, _
                                     epcbJustifyVCenter, _
                                     Nothing, _
                                     units)
    End If
End Function

Function DrawRectangle(objUserLayer, originX, originY, ByVal width, ByVal height, bFill, units)
	' If the user layer passed in is Nothing, then draw motion graphics
	height = height / 2
	
	If objUserLayer Is Nothing Then
		
		Call pcbDoc.ActiveView.MotionGfxPutRect(originX, originY - height, epcbMotionGfxPointMoveXY, _
			originX + width, originY + height, epcbMotionGfxPointMoveXY, _
			tagMotion, 1, Nothing, units)
	Else
	   ' get the rectangular points array for this layer
       pntsArr = GetRectPntsArray(originX, originY, width, height)
            
       ' put the rectangle on the user layer
       Set rectObj = pcbDoc.PutUserLayerGfx(objUserLayer, 0, _
            numOfPnts, pntsArr, bFill, Nothing, units)
    End If
End Function

Function DrawLine(objUserLayer, originX, originY, endX, endY, units)
	
	If objUserLayer Is Nothing Then
		Call pcbDoc.ActiveView.MotionGfxPutLine(originX, originY, epcbMotionGfxPointMoveXY, _
			endX, endY, epcbMotionGfxPointMoveXY, _
			tagMotion, dimlinewidth, Nothing, units)
	Else
	   ' get the rectangular points array for this layer
       pntsArr = GetLinePntsArray(originX, originY, endX, endY)
            
       ' put the rectangle on the user layer
       Set lineObj = pcbDoc.PutUserLayerGfx(objUserLayer, dimlinewidth, _
            2, pntsArr, , Nothing, units)
    End If
	
	
End Function

Function DrawArrow(objUserLayer, x, y, angle, units)
	
	dim ptary(2,3)
	dim n
	dim x1
	dim y1
	
	'create the triangle pointsarray
	ptary(0, 0) = 0
	ptary(1, 0) = 0
	ptary(2, 0) = 0
	ptary(0, 1) = - dimarrowlength
	ptary(1, 1) = dimarrowwidth / 2
	ptary(2, 1) = 0
	ptary(0, 2) = - dimarrowlength
	ptary(1, 2) = - dimarrowwidth / 2
	ptary(2, 2) = 0
	ptary(0, 3) = 0
	ptary(1, 3) = 0
	ptary(2, 3) = 0
	

	
	
	
	'rotate the pointsarray
	if not angle = 0 then
		for n = 0 to ubound(ptary, 2)
			x1 = ptary(0, n)
			y1 = ptary(1, n)
			ptary(0, n) = get_rotated_x_coordinate(x1, y1, angle)
			ptary(1, n) = get_rotated_y_coordinate(x1, y1, angle)
		next
	end if
	
	
	'translate the pointsarray to x, y
	for n = 0 to ubound(ptary, 2)
		ptary(0, n) = ptary(0, n) + x
		ptary(1, n) = ptary(1, n) + y
	next
	
	If objUserLayer Is Nothing Then
		Call pcbDoc.ActiveView.MotionGfxPutPointsArray(ptary, epcbMotionGfxPointMoveXY, tagMotion, dimlinewidth, Nothing, units)
	Else
       Set arrowObj = pcbDoc.PutUserLayerGfx(objUserLayer, dimlinewidth, 4, ptary, true, Nothing, units)
    End If
	
	
	
	
	
	
	
	

End Function

Public Function get_rotated_x_coordinate(x, y, r)
	Dim x1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	x1 = (x * Cos(r1)) - (y * Sin(r1))
	
	get_rotated_x_coordinate = x1
End Function

Public Function get_rotated_y_coordinate(x, y, r)
	Dim y1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	y1 = (x * Sin(r1)) + (y * Cos(r1))
	
	get_rotated_y_coordinate = y1
End Function

Function GetLinePntsArray(ByVal x1, ByVal y1, ByVal x2, ByVal y2)
	Dim pntsArray(2,1)
	
	pntsArray(0,0) = x1
    pntsArray(1,0) = y1
    pntsArray(2,0) = 0
    pntsArray(0,1) = x2
    pntsArray(1,1) = y2
    pntsArray(2,1) = 0
	
	
	GetLinePntsArray = pntsArray
End Function

Function GetRectPntsArray(ByVal originX, ByVal originY, ByVal width, ByVal height)
    Dim pntsArray(2,5)
	
	
    
    pntsArray(0,0) = originX
    pntsArray(1,0) = originY - height
    pntsArray(2,0) = 0
    pntsArray(0,1) = originX
    pntsArray(1,1) = originY + height
    pntsArray(2,1) = 0
    pntsArray(0,2) = originX + width
    pntsArray(1,2) = originY + height
    pntsArray(2,2) = 0
    pntsArray(0,3) = originX + width
    pntsArray(1,3) = originY - height
    pntsArray(2,3) = 0
    pntsArray(0,4) = originX
    pntsArray(1,4) = originY - height
    pntsArray(2,4) = 0
    
    GetRectPntsArray = pntsArray
End Function

Function DrawMotionGraphics(x, y)
    Call ClearMotionGraphics()
	tagMotion = pcbDoc.ActiveView.MotionGfxGetTag()
   	Call GenerateStackupGraphics(Nothing, x, y)
    pcbDoc.ActiveView.MotionGfxDrawAnyUndrawn
End Function

Function ClearMotionGraphics()
	pcbDoc.ActiveView.MotionGfxDeleteByTag(tagMotion)
	tagMotion = -1
End Function

Function getpntcmd_OnMouseClk(button, flags, dx, dy)
    If button = epcbMouseButtonLeft Then
        Call ClearMotionGraphics()
		Call GenerateStackupGraphicsOnUserLayer(dx, dy)
        getpntcmd_OnMouseClk = True
		Gui.TerminateCommand
    End If
End Function

Function getpntcmd_OnTerminate()
	ClearMotionGraphics
	Set GetPointCmd = Nothing
End Function

Function set_units()
		
	'set all units in mils, then convert from there
	dielectricBoxX = 800   'width of the box for the dielectric layers
	dielectricBoxY = 100   'height of the box for the dielectric layers
	traceBoxX = 150        'width of the box for trace layers (two each layer)
	traceBoxY = 25         'height of the box for trace layers
	traceBox1OffsetX = 150 'start position of first trace box
	traceBox2OffsetX = 500 'start position of second trace box
	planeBoxX = 800        'width of the box for plane layers
	planeBoxY = 25         'height of the box for plane layers
	textOffsetX = 1000      'X offset for text for each layer
	textOffsetYdie = 50    'Y offset for text for dielectric layer
	textOffsetYsm = 5    'Y offset for text for solder mask layer
	textOffsetYcond = 5   'Y offset for text for conductive layers
	textHeight = 80        'height of text
	stepCondY = 250        'spacing above conductive layer
	stepDieY = 175         'spacing above dielectric layer
	stepTitleY = 450      'spacing in title area
	titleTextOffestX = 450 'start position of title text
	sm_box = 15			'height of the box for soldermask layers
	dimbarwidth	= 100	'half the width of the dimension crossbars
	dimoffsetx = 450	'offset (to the left of the layer boxes) of the dimension line
	dimlinewidth = 1	'linewidth of the dimension lines
	dimarrowlength = 80	'dimension arrow length
	dimarrowwidth = 27	'dimension arrow width
	dimgap = 40			'gap between layer box and dimension bar	
	stepY = 200			'Y gap between all layers



	Select Case pcbDoc.currentunit
		Case 2	'mils
				'no change
				
		Case 3	'inches
			dielectricBoxX = dielectricBoxX * .001
			dielectricBoxY = dielectricBoxX * .001
			traceBoxX = traceBoxX * .001
			traceBoxY = traceBoxY * .001
			traceBox1OffsetX = traceBox1OffsetX * .001
			traceBox2OffsetX = traceBox2OffsetX * .001
			planeBoxX = planeBoxX * .001
			planeBoxY = planeBoxY * .001
			textOffsetX = textOffsetX * .001
			textOffsetYdie = textOffsetYdie * .001
			textOffsetYsm = textOffsetYsm * .001
			textOffsetYcond = textOffsetYcond
			textHeight = textHeight * .001
			stepCondY = stepCondY * .001
			stepDieY = stepDieY * .001
			stepTitleY = stepTitleY * .001
			titleTextOffestX = titleTextOffestX * .001
			sm_box = sm_box * .001
			dimbarwidth = dimbarwidth * .001
			dimoffsetx = dimoffsetx * .001
			dimlinewidth = dimlinewidth * .001
			dimarrowlength = dimarrowlength * .001
			dimarrowwidth = dimarrowwidth * .001
			dimgap = dimgap * .001
			stepY = stepY * .001
		Case 4	'mm
			dielectricBoxX = dielectricBoxX * .0254
			dielectricBoxY = dielectricBoxX * .0254
			traceBoxX = traceBoxX * .0254
			traceBoxY = traceBoxY * .0254
			traceBox1OffsetX = traceBox1OffsetX * .0254
			traceBox2OffsetX = traceBox2OffsetX * .0254
			planeBoxX = planeBoxX * .0254
			planeBoxY = planeBoxY * .0254
			textOffsetX = textOffsetX * .0254
			textOffsetYdie = textOffsetYdie * .0254
			textOffsetYsm = textOffsetYsm * .0254
			textOffsetYcond = textOffsetYcond * .0254
			textHeight = textHeight * .0254
			stepCondY = stepCondY * .0254
			stepDieY = stepDieY * .0254
			stepTitleY = stepTitleY * .0254
			titleTextOffestX = titleTextOffestX * .0254
			sm_box = sm_box * .0254
			dimbarwidth = dimbarwidth * .0254
			dimoffsetx = dimoffsetx * .0254
			dimlinewidth = dimlinewidth * .0254
			dimarrowlength = dimarrowlength * .0254
			dimarrowwidth = dimarrowwidth * .0254
			dimgap = dimgap * .0254
			stepY = stepY * .0254
		Case 5	'um
			dielectricBoxX = dielectricBoxX * 25.4
			dielectricBoxY = dielectricBoxX * 25.4
			traceBoxX = traceBoxX * 25.4
			traceBoxY = traceBoxY * 25.4
			traceBox1OffsetX = traceBox1OffsetX * 25.4
			traceBox2OffsetX = traceBox2OffsetX * 25.4
			planeBoxX = planeBoxX * 25.4
			planeBoxY = planeBoxY * 25.4
			textOffsetX = textOffsetX * 25.4
			textOffsetYdie = textOffsetYdie * 25.4
			textOffsetYsm = textOffsetYsm * 25.4
			textOffsetYcond = textOffsetYcond * 25.4
			textHeight = textHeight * 25.4
			stepCondY = stepCondY * 25.4
			stepDieY = stepDieY * 25.4
			stepTitleY = stepTitleY * 25.4
			titleTextOffestX = titleTextOffestX * 25.4
			sm_box = sm_box * 25.4
			dimbarwidth = dimbarwidth * 25.4
			dimoffsetx = dimoffsetx * 25.4
			dimlinewidth = dimlinewidth * 25.4
			dimarrowlength = dimarrowlength * 25.4
			dimarrowwidth = dimarrowwidth * 25.4
			dimgap = dimgap * 25.4
			stepY = stepY * 25.4
	
	End Select


End Function

'---------------------------------------
' Begin Validate Server Function
'---------------------------------------
Private Function ValidateServer(doc)
    
    Dim key, licenseServer, licenseToken

    ' Ask Expeditions document for the key
    key = doc.Validate(0)

    ' Get license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")

    ' Ask the license server for the license token
    licenseToken = licenseServer.GetToken(key)

    ' Release license server
    Set licenseServer = nothing

    ' Turn off error messages.  Validate may fail if the token is incorrect
    On Error Resume Next
    Err.Clear

    ' Ask the document to validate the license token
    doc.Validate(licenseToken)
    If Err Then
        ValidateServer = 0    
    Else
        ValidateServer = 1
    End If

End Function
'---------------------------------------
' End Validate Server Function
'---------------------------------------
