Option explicit
	
	dim app
	dim doc
	dim gui

	dim prog_id
	Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
	
	Set doc = GetLicensedDoc(app)
	set gui = app.gui
	msgbox "alt-n"
	run
	
Public Sub run
	dim pins
	dim pin
	dim planes
	dim plane
	dim cshape
	dim cshapes
	dim vias
	dim via
	dim traces
	dim trace
	dim net
	dim x, y, x1, y1, x2, y2, r
	dim geom
	dim ptary
	dim pts
	dim gfx
	dim layer
	dim n, i
	dim drc
	dim std
	dim via_path
	dim anchor
	
	via_path = false
	
	layer = gui.ActiveRouteLayer
	
	
	
	If not doc is nothing then
		std = gui.SuppressTrivialDialogs
		gui.SuppressTrivialDialogs = true
		
		set pins = doc.pins(1)
		set planes = doc.planeshapes(1)
		set cshapes = doc.conductiveareas(1)
		set vias = doc.vias(1)
		set traces = doc.traces(1)
		
		if pins.count = 0 and vias.count = 0 then
			msgbox "No pins or vias selected"
			exit sub
		end if
		
		if pins.count = 0 and vias.count > 0 then
			via_path = true
		end if
		
		if pins.count > 0 and vias.count > 0 then
			
		end if
		
		if traces.count > 0 Then
			change_trace_net
			exit sub
		end if
		
		if doc.transactionstart(0) = true then
			if via_path = true then
			
				for each via in vias
					set net = via.net
				next
				
				if planes.count > 0 then
					n = 0
					for each plane in planes
						anchor = plane.anchor
						set plane.anchor = 0
						set plane.net = net
						set plane.anchor = anchor
						n = n + 1
					next
				end if
				
				if cshapes.count > 0 then
					for each cshape in cshapes
						set cshape.net = net
					next
				end if
			else
				
				
				for each pin in pins
					set net = pin.net
					exit for
				next
				
				if planes.count > 0 then
					for each plane in planes
						set plane.net = net
					next
				end if
				
				if cshapes.count > 0 then
					for each cshape in cshapes
						set cshape.net = net
					next
				end if
				
				if vias.count > 0 then
					for each via in vias
						set via.net = net
					next
				end if
				
			end if
			
			doc.transactionend(true)
		end if
		
		
		gui.SuppressTrivialDialogs = std
	end if
	
	msgbox "done with alt+n"

End Sub

Sub change_trace_net()
	dim traces
	dim trace
	dim pins
	dim pin
	dim net
	dim vias
	dim via
	dim w
	dim layer
	dim ptary
	dim geom
	dim pts
	dim tmp
	
	msgbox "traces"
	
	set traces = doc.traces(1)
	set pins = doc.pins(1)
	set vias = doc.vias(1)
	
	
	if vias.count > 0 then
		for each via in vias
			set via.net = net
		next
	end if
	
	if pins.count  > 0 then
		for each pin in pins
			set net = pin.net
		next
	end if

	
	for each trace in traces
		layer = trace.layer
		set geom = trace.geometry
		w = geom.linewidth
		ptary = geom.pointsarray
		pts = ubound(ptary, 2) + 1
		trace.selected = true
		'set trace.fixlock = 0
		
		
		trace.delete()
		if doc.transactionstart(0) = true Then
			doc.puttrace layer, net, w, pts, ptary, nothing
			doc.TransactionEnd(True)
		end if
	next
	

	
	
End Sub


'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
