Option explicit

dim nets
dim net
dim app
dim doc
dim gui
dim shell
dim regkey
dim local_app_data
dim idx
dim fso
dim file
dim filepath
dim n
dim tmp
dim ary
dim prog_id

Set shell = CreateObject("WScript.Shell")

'get the value of prog_id from the registry
'regkey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\MGCPCB.DrawingEditorApplication\CurVer\"
'tmp = objShell.RegRead(regkey) 
'tmp = mid(tmp,InStrRev(tmp, ".") + 1)
'prog_id = tmp

get_id()



'Hook to Expedition
Set app = GetObject(, "MGCPCB.DrawingEditorApplication")
'Set app = GetObject(, "MGCPCB.DrawingEditorApplication")
Set doc = GetLicensedDoc(app)


'create the file system object
'this is necessary because vbscript cannot write to the Windows clipboard
Set fso=CreateObject("Scripting.FileSystemObject")

'get the temp filename from the design's path
filepath = doc.fullname
filepath  = left(filepath, instrrev(filepath, "\"))
filepath = filepath & "Output\tmpfile.txt"


If not doc is nothing then
	set nets = doc.nets(1, true)
	n = 0
	tmp = ""
	for each net in nets
		tmp = tmp & net.name
		tmp = tmp & vbcrlf
		tmp = replace(tmp, " ", "")
		n = n + 1

		
	next
	Set file = fso.CreateTextFile(filepath,True)
	file.Write tmp
	file.Close
	shell.Run "cmd /C CLIP < " & filepath, 2
End if

set shell = nothing
set nets = nothing
set net = nothing
set tmp = nothing
Set app = Nothing
Set doc = Nothing



Public Sub get_id()
	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If


End Sub



Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function

