Option Explicit

Dim app       ' The application
Dim doc     ' The Board
Dim gui
Dim BindMenu
Dim BindAccelerator
Dim BindCommand
Dim keyBindTables
dim path
dim shell

Set app = Application
Set doc = app.ActiveDocument
Set gui = app.gui

Scripting.AddTypeLibrary("MGCPCB.ExpeditionPCBApplication")
Set shell = CreateObject( "WScript.Shell" )
path = shell.ExpandEnvironmentStrings("%EXACTCAD_PATH%") & "\bin\hotkeys"
scripting.globals("path") = path
set shell = nothing

BindMenu = 0
BindAccelerator = 1
BindCommand = 1

Set keyBindTables = gui.Bindings("Document")


'align
keyBindTables.AddKeyBinding "a", "run " & path & "\align.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "A", "run " & path & "\align.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Shift+a", "run " & path & "\align_tp.vbs", BindCommand, BindAccelerator

'run Move with Basepoint
keyBindTables.AddKeyBinding "m", "run " & path & "\move_with_basepoint.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "M", "run " & path & "\move_with_basepoint.vbs", BindCommand, BindAccelerator

'run move compenent to center of drawn objects
keyBindTables.AddKeyBinding "Alt+m", "run " & path & "\move_part_to_cenroid_of_draw_objects.vbs", BindCommand, BindAccelerator 
 
'Find and replace userlayer text
keyBindTables.AddKeyBinding "Ctrl+h", "run " & path & "\find_and_replace_userlayer_text.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+H", "run " & path & "\find_and_replace_userlayer_text.vbs", BindCommand, BindAccelerator


'RF & Power Pin Exit
keyBindTables.AddKeyBinding "p", "run " & path & "\RF_and_Power_Pin_Exit.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "P", "run " & path & "\RF_and_Power_Pin_Exit.vbs", BindCommand, BindAccelerator


'strokes for aligning components top bottom, left, right
keyBindTables.AddStrokeBinding "852", "run " & path & "\align_top.vbs", BindCommand, BindAccelerator
keyBindTables.AddStrokeBinding "258", "run " & path & "\align_bottom.vbs", BindCommand, BindAccelerator
keyBindTables.AddStrokeBinding "654", "run " & path & "\align_left.vbs", BindCommand, BindAccelerator
keyBindTables.AddStrokeBinding "456", "run " & path & "\align_right.vbs", BindCommand, BindAccelerator

'Move to Next
keyBindTables.AddKeyBinding "Ctrl+Num9", "run " & path & "\move_to_next_45.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+Num7", "run " & path & "\move_to_next_135.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+Num1", "run " & path & "\move_to_next_225.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+Num3", "run " & path & "\move_to_next_315.vbs", BindCommand, BindAccelerator

'normalize lines
keyBindTables.AddKeyBinding "Alt+l", "run " & path & "\normalize_line.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+L", "run " & path & "\normalize_line.vbs", BindCommand, BindAccelerator


'select entire net
keyBindTables.AddKeyBinding "`", "run " & path & "\select_entire_net.vbs", BindCommand, BindAccelerator

'lock selected
keyBindTables.AddKeyBinding "Ctrl+`", "run " & path & "\lock_selected.vbs", BindCommand, BindAccelerator

'select entire net and lock it
keyBindTables.AddKeyBinding "Ctrl+1", "run " & path & "\select_entire_net_and_lock.vbs", BindCommand, BindAccelerator

'select entire net and highlight it
keyBindTables.AddKeyBinding "Alt+F1", "run " & path & "\select_entire_net_and_highlight.vbs", BindCommand, BindAccelerator

'unhighlight all
keyBindTables.AddKeyBinding "Ctrl+F1", "run " & path & "\unhighlight_all.vbs", BindCommand, BindAccelerator

'set top/bottom layer active 
keyBindTables.AddKeyBinding "1", "run " & path & "\set_active_layer_top.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "2", "run " & path & "\set_active_layer_bottom.vbs", BindCommand, BindAccelerator

'unlock selected
keyBindTables.AddKeyBinding "3", "run " & path & "\unlock_selected.vbs", BindCommand, BindAccelerator

'select entire net and unlock it
keyBindTables.AddKeyBinding "Ctrl+3", "run " & path & "\select_entire_net_and_unlock.vbs", BindCommand, BindAccelerator

'unlock selected then delete it
keyBindTables.AddKeyBinding "Alt+3", "run " & path & "\unlock_and_delete.vbs", BindCommand, BindAccelerator

'set trace width equal to pad width while routing off pad
keyBindTables.AddKeyBinding "Shift+w", "run " & path & "\set_trace_width_to_pad.vbs", BindCommand, BindAccelerator

'set trace width equal to narrow pad dimention
keyBindTables.AddKeyBinding "Ctrl+t", "run " & path & "\set_trace_width_to_pad_min.vbs", BindCommand, BindAccelerator

'set trace width equal to wide pad dimention
keyBindTables.AddKeyBinding "alt+t", "run " & path & "\set_trace_width_to_pad_max.vbs", BindCommand, BindAccelerator

'get active route width
keyBindTables.AddKeyBinding "w", "run " & path & "\get_active_route_width.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "W", "run " & path & "\get_active_route_width.vbs", BindCommand, BindAccelerator


'Rotate component 45°
keyBindTables.AddKeyBinding "Ctrl+r", "run " & path & "\rotate45.vbs", BindCommand, BindAccelerator

'Rotate group 45°
keyBindTables.AddKeyBinding "Shift+r", "run " & path & "\rotate45_group.vbs", BindCommand, BindAccelerator

'Rotate group by angle°
keyBindTables.AddKeyBinding "Ctrl+Shift+r", "run " & path & "\rotate_group_by_angle.vbs", BindCommand, BindAccelerator

'Restore Silkscreen Text
keyBindTables.AddKeyBinding "Shift+Alt+r", "run " & path & "\restore_silk_refdes.vbs", BindCommand, BindAccelerator



'change via to GND Net
keyBindTables.AddKeyBinding "Ctrl+g", "run " & path & "\via_to_ground.vbs", BindCommand, BindAccelerator

'place plane shape
keyBindTables.AddKeyBinding "Shift+p", "run " & path & "\plane_shape.vbs", BindCommand, BindAccelerator

'copy net name to clipboard
keyBindTables.AddKeyBinding "n", "run " & path & "\copy_net_name_to_cliboard.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "N", "run " & path & "\copy_net_name_to_cliboard.vbs", BindCommand, BindAccelerator

'edit text
keyBindTables.AddKeyBinding "Alt+e", "run " & path & "\edit_text.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+E", "run " & path & "\edit_text.vbs", BindCommand, BindAccelerator


'clump parts
keyBindTables.AddKeyBinding "g", "run " & path & "\clump_parts.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "G", "run " & path & "\clump_parts.vbs", BindCommand, BindAccelerator

'swap parts
keyBindTables.AddKeyBinding "Alt+s", "run " & path & "\swap_parts.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+S", "run " & path & "\swap_parts.vbs", BindCommand, BindAccelerator

'swap traces
keyBindTables.AddKeyBinding "Shift+s", "run " & path & "\swap_traces.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Shift+S", "run " & path & "\swap_traces.vbs", BindCommand, BindAccelerator

'trim traces
keyBindTables.AddKeyBinding "t", "run " & path & "\trim_traces.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "T", "run " & path & "\trim_traces.vbs", BindCommand, BindAccelerator

'change net of selected plane shape to net of selected pin
keyBindTables.AddKeyBinding "Alt+n", "run " & path & "\change_net_to_selected_pin_net.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+N", "run " & path & "\change_net_to_selected_pin_net.vbs", BindCommand, BindAccelerator


'set route, place, and draw modes
keyBindTables.AddKeyBinding "r", "run " & path & "\set_route_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "R", "run " & path & "\set_route_mode.vbs", BindCommand, BindAccelerator

keyBindTables.AddKeyBinding "d", "run " & path & "\set_draw_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "D", "run " & path & "\set_draw_mode.vbs", BindCommand, BindAccelerator

keyBindTables.AddKeyBinding "c", "run " & path & "\set_place_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "C", "run " & path & "\set_place_mode.vbs", BindCommand, BindAccelerator

'Set Selection Mode
keyBindTables.AddKeyBinding "Alt+a", "run " & path & "\set_selection_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+A", "run " & path & "\set_selection_mode.vbs", BindCommand, BindAccelerator


'toggle edit layer only
keyBindTables.AddKeyBinding "e", "run " & path & "\toggle_edit_layer_only.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "E", "run " & path & "\toggle_edit_layer_only.vbs", BindCommand, BindAccelerator

'join lines
keyBindTables.AddKeyBinding "j", "run " & path & "\join_lines.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "J", "run " & path & "\join_lines.vbs", BindCommand, BindAccelerator


'lock / unlock components
keyBindTables.AddKeyBinding "l", "run " & path & "\lock_components.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "L", "run " & path & "\lock_components.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "u", "run " & path & "\unlock_components.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "U", "run " & path & "\unlock_components.vbs", BindCommand, BindAccelerator

'set DRC on/off
keyBindTables.AddKeyBinding "x", "run " & path & "\toggle_drc.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "X", "run " & path & "\toggle_drc.vbs", BindCommand, BindAccelerator

'toggle via visibility
keyBindTables.AddKeyBinding "v", "run " & path & "\toggle_vias_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "V", "run " & path & "\toggle_vias_on_off.vbs", BindCommand, BindAccelerator 

'toggle traces visibility
keyBindTables.AddKeyBinding "Shift+t", "run " & path & "\toggle_traces_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Shift+T", "run " & path & "\toggle_traces_on_off.vbs", BindCommand, BindAccelerator 

'toggle pins visibility
keyBindTables.AddKeyBinding "Alt+p", "run " & path & "\toggle_pins_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Alt+P", "run " & path & "\toggle_pins_on_off.vbs", BindCommand, BindAccelerator 

'toggle visibility of everything but traces
keyBindTables.AddKeyBinding "Ctrl+Shift+t", "run " & path & "\toggle_everything_off_but_traces.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Ctrl+Shift+T", "run " & path & "\toggle_everything_off_but_traces.vbs", BindCommand, BindAccelerator

'toggle planes visibility
keyBindTables.AddKeyBinding "Ctrl+Shift+p", "run " & path & "\toggle_planes_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Ctrl+Shift+p", "run " & path & "\toggle_planes_on_off.vbs", BindCommand, BindAccelerator

'toggle Conductive Shapes visibility
keyBindTables.AddKeyBinding "Ctrl+Shift+a", "run " & path & "\toggle_conductive_areas.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Ctrl+Shift+A", "run " & path & "\toggle_conductive_areas.vbs", BindCommand, BindAccelerator

'toggle hover snap
keyBindTables.AddKeyBinding "s", "run " & path & "\toggle_hover_snap.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "S", "run " & path & "\toggle_hover_snap.vbs", BindCommand, BindAccelerator 

'toggle dim mode
keyBindTables.AddKeyBinding "Alt+D", "run " & path & "\toggle_dim_mode.vbs", BindCommand, BindAccelerator

'exit 45
keyBindTables.AddKeyBinding "4", "run " & path & "\exit_45.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+4", "run " & path & "\exit_45-anti.vbs", BindCommand, BindAccelerator

'set design control schemes 1 & 2
keyBindTables.AddKeyBinding "Alt+1", "run " & path & "\set_dc_scheme_1.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+2", "run " & path & "\set_dc_scheme_2.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+q", "run " & path & "\toggle_wall_source_layer_1.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+q", "run " & path & "\toggle_wall_source_layer_2.vbs", BindCommand, BindAccelerator

'change userlayer
keyBindTables.AddKeyBinding "Alt+c", "run " & path & "\change_userlayer.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+C", "run " & path & "\change_userlayer.vbs", BindCommand, BindAccelerator



