Option Explicit

Dim app       ' The application
Dim doc     ' The Board
Dim gui
Dim BindMenu
Dim BindAccelerator
Dim BindCommand
Dim keyBindTables
dim path
dim shell

Set app = Application
Set doc = app.ActiveDocument
Set gui = app.gui

Scripting.AddTypeLibrary("MGCPCB.DrawingEditorApplication")
Set shell = CreateObject( "WScript.Shell" )
path = shell.ExpandEnvironmentStrings("%EXACTCAD_PATH%") & "\bin\hotkeys\de"
scripting.globals("path") = path
set shell = nothing

BindMenu = 0
BindAccelerator = 1
BindCommand = 1

Set keyBindTables = gui.Bindings("Document")

'run Move with Basepoint
keyBindTables.AddKeyBinding "m", "run " & path & "\move_with_basepoint.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "M", "run " & path & "\move_with_basepoint.vbs", BindCommand, BindAccelerator

'Find and replace userlayer text
keyBindTables.AddKeyBinding "Ctrl+h", "run " & path & "\find_and_replace_userlayer_text.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Ctrl+H", "run " & path & "\find_and_replace_userlayer_text.vbs", BindCommand, BindAccelerator

'unhighlight all
keyBindTables.AddKeyBinding "Ctrl+F1", "run " & path & "\unhighlight_all.vbs", BindCommand, BindAccelerator

'set top/bottom layer active 
keyBindTables.AddKeyBinding "1", "run " & path & "\set_active_layer_top.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "2", "run " & path & "\set_active_layer_bottom.vbs", BindCommand, BindAccelerator

'unlock selected
keyBindTables.AddKeyBinding "3", "run " & path & "\unlock_selected.vbs", BindCommand, BindAccelerator

'copy net name to clipboard
keyBindTables.AddKeyBinding "n", "run " & path & "\copy_net_name_to_cliboard.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "N", "run " & path & "\copy_net_name_to_cliboard.vbs", BindCommand, BindAccelerator

'edit text
keyBindTables.AddKeyBinding "Alt+e", "run " & path & "\edit_text.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+E", "run " & path & "\edit_text.vbs", BindCommand, BindAccelerator

'set place and draw modes
keyBindTables.AddKeyBinding "d", "run " & path & "\set_draw_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "D", "run " & path & "\set_draw_mode.vbs", BindCommand, BindAccelerator

keyBindTables.AddKeyBinding "c", "run " & path & "\set_place_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "C", "run " & path & "\set_place_mode.vbs", BindCommand, BindAccelerator

'Set Selection Mode
keyBindTables.AddKeyBinding "Alt+a", "run " & path & "\set_selection_mode.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+A", "run " & path & "\set_selection_mode.vbs", BindCommand, BindAccelerator


'toggle edit layer only
keyBindTables.AddKeyBinding "e", "run " & path & "\toggle_edit_layer_only.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "E", "run " & path & "\toggle_edit_layer_only.vbs", BindCommand, BindAccelerator

'join lines
keyBindTables.AddKeyBinding "j", "run " & path & "\join_lines.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "J", "run " & path & "\join_lines.vbs", BindCommand, BindAccelerator


'toggle via visibility
keyBindTables.AddKeyBinding "v", "run " & path & "\toggle_vias_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "V", "run " & path & "\toggle_vias_on_off.vbs", BindCommand, BindAccelerator 

'toggle traces visibility
keyBindTables.AddKeyBinding "Shift+t", "run " & path & "\toggle_traces_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Shift+T", "run " & path & "\toggle_traces_on_off.vbs", BindCommand, BindAccelerator 

'toggle pins visibility
keyBindTables.AddKeyBinding "Alt+p", "run " & path & "\toggle_pins_on_off.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "Alt+P", "run " & path & "\toggle_pins_on_off.vbs", BindCommand, BindAccelerator 

'toggle hover snap
keyBindTables.AddKeyBinding "s", "run " & path & "\toggle_hover_snap.vbs", BindCommand, BindAccelerator 
keyBindTables.AddKeyBinding "S", "run " & path & "\toggle_hover_snap.vbs", BindCommand, BindAccelerator 

'toggle dim mode
keyBindTables.AddKeyBinding "Alt+D", "run " & path & "\toggle_dim_mode.vbs", BindCommand, BindAccelerator

'change userlayer
keyBindTables.AddKeyBinding "Alt+c", "run " & path & "\change_userlayer.vbs", BindCommand, BindAccelerator
keyBindTables.AddKeyBinding "Alt+C", "run " & path & "\change_userlayer.vbs", BindCommand, BindAccelerator



