Option explicit

dim app
dim doc
dim gui
dim shell
dim regkey
dim local_app_data
dim idx
dim fso
dim file
dim tmp
dim ref
dim ary
dim prog_id
dim sl


get_id()

'Hook to Expedition
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)

set gui = app.gui

if not doc is nothing Then
	run
end if

Set app = Nothing
Set doc = Nothing


Sub run
	dim comps
	dim comp
	dim ulgs
	dim ulg
	dim pos
	dim po
	dim extc, ext
	dim x1, x2, y1, y2, x, y
	dim minx, maxx, miny, maxy
	
	
	set comps = doc.components(1)
	set ulgs = doc.userlayergfxs(1)
	
	for each comp in comps
		set pos = comp.placementoutlines
		for each po in pos
			set extc = po.extrema
			x1 = (extc.maxx + extc.minx) / 2
			y1 = (extc.maxy + extc.miny) / 2
			
			minx = 1000000000
			miny = 1000000000
			maxx = -1000000000
			maxy = -1000000000
			for each ulg in ulgs
				set ext = ulg.extrema
				if ext.minx < minx then minx = ext.minx
				if ext.miny < miny then miny = ext.miny
				if ext.maxx > maxx then maxx = ext.maxx
				if ext.maxy > maxy then maxy = ext.maxy
			next
			
			x2 = (maxx + minx) / 2
			y2 = (maxy + miny) / 2
			
			x = x2 - x1
			y = y2 - y1
			if doc.transactionstart(0) = true Then
				comp.move x2, y2, doc.currentunit
				doc.transactionend(true)
			end if
			
		Next
	next
	
	
	
	
	
	
	
	

End Sub

Public Function Sort( ByRef arrSample )
	Dim i, j, strHolder
	dim a1, a2
	dim k, l
	dim intNumber
	dim TempValue
	
	
	tmp =  "array before"
	For Each intNumber In arrSample
	  tmp = tmp & intNumber & vbcrlf
	Next
	For i = LBound(arrSample) to UBound(arrSample)
	  For j = LBound(arrSample) to UBound(arrSample)
		If j <> UBound(arrSample) Then
			a1 = split(arrSample(j), " ")
			k = cdbl(a1(0))
			
			a2 = split(arrSample(j + 1), " ")
			l = cdbl(a2(0))
		  If k < l Then
			 TempValue = arrSample(j + 1)
			 arrSample(j + 1) = arrSample(j)
			 arrSample(j) = TempValue
		  End If
		End If
	  Next
	Next
	tmp = tmp &  vbCrLf & "array after"
	For Each intNumber In arrSample
	  tmp = tmp & intNumber & vbcrlf
	Next
	
	'msgbox tmp
	

	' For i = 0 to ubound(myArray)
		' a1 = split(myArray(i), " ")
		' k = a1(0)
		
		' For j= k + 1 to ubound(myArray)
			
			' a2 = split(myArray(j), " ")
			' l = a2(0)
			
			' If k > l Then
				' strHolder = myArray(i)
				' myArray(i) = myArray(j)
				' myArray(j) = strHolder
			' End If
		' Next
	' Next 
	
	Sort = arrSample
End Function


Public Sub get_id()
	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
