Option explicit

dim app
dim doc
dim gui

dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)
set gui = app.gui

rotate_group


Sub rotate_group()
		If not doc is nothing then
		
		dim comp
		dim comps
		Dim n
		Dim locs()
		Dim loc()
		dim tmp
		Dim centx_sum, centy_sum, centx, centy
		Dim x, y, x1, y1, r1, ra
		
		ra = inputbox("By what angle do you want to rotate the parts?")
		

		
		set comps = doc.Components(1)
		gui.SuppressNotepadDialogs = True
		
		n = 0
		for each comp in comps
			n = n + 1
		next
		
		if n = 0 then exit sub
		
		redim locs(n - 1, 1)
		
		n = 0
		tmp = ""
		centx_sum = 0
		centy_sum = 0
		for each comp in comps
			locs(n, 0) = comp.positionx
			centx_sum = centx_sum + comp.positionx
			locs(n, 1) = comp.positiony
			centy_sum = centy_sum + comp.positiony
			tmp = tmp & locs(n, 0) & "," & locs(n, 1) & vbcrlf
			n = n + 1
		next
		
		'get the centroid of all the selected components
		centx = centx_sum / n
		centy = centy_sum / n
		

		'do the rotation
		If doc.TransactionStart(0) = True Then
			for each comp in comps
				comp.move comp.positionx + doc.boardoutline.extrema.maxx, comp.positiony, 0
			Next
			
			for each comp in comps
				x = comp.positionx - doc.boardoutline.extrema.maxx - centx
				y = comp.positiony - centy
				
				'change ra to randians
				r1 = (ra * 3.14159) / 180
				x1 = (x * Cos(r1)) - (y * Sin(r1))
				y1 = (x * Sin(r1)) + (y * Cos(r1))
				x = x1 + centx
				y = y1 + centy
				comp.move x, y, 0
				comp.orientation = comp.orientation + ra
			Next
			doc.TransactionEnd(True)
		End If

	End if
	
	gui.SuppressNotepadDialogs = False
	
	Set app = Nothing
	Set doc = Nothing
	
	

End Sub


Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub




Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
