Option Explicit     ' All variables must be declared using the 'Dim' statement
Scripting.DontExit = True ' Hang around to listen to events

dim app
dim doc
dim gui
dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)
set gui = app.gui

Dim tagMotion : tagMotion = -1
Dim GetPointCmd
dim x
dim y
dim pins
dim pin
dim d	'this will be used to make the pick box
dim nets
dim net
dim net_name


launch()

get_location()	'this starts the mouse movement monitor

'then getpntcmd_OnMouseMove captures mouse movement


Sub launch()
	' add a reference to the MGCPCB type library in order to use enums
    Scripting.AddTypeLibrary("MGCPCB.ExpeditionPCBApplication")



	d = 30	'mils
	
	select case doc.currentunit
		case 2
			'd = 10
		case 3
			d = d * .001
		case 4
			d = d * .0254
		case 5
			d = d * 25.4
	End Select
	
	
End Sub

Sub get_location()
	' register a cmd so we can get a mouse point
	'this starts the mouse movement monitor
    Set GetPointCmd = gui.RegisterCommand("GetPoint")
    
    ' attach the events to the command
    Scripting.AttachEvents GetPointCmd, "getpntcmd"
	
	
End sub

Function getpntcmd_OnMouseMove(button, flags, dx, dy)
	dim d
	dim min
	dim px, py, pdx, pdy, w, r, x1, y1
	dim minx, miny, maxx, maxy
	dim pin
	dim objs, obj
	dim comp
	dim cx, cy
	dim layer
	dim pads
	dim pad
	dim geom
	dim geoms
	dim ptary
	dim n
	dim via_conn
	dim via_conns
	dim via
	dim trace
	
	dim lobjs
	dim lobj
	
	layer = gui.activeroutelayer
	set lobj = app.Utility.NewLayerObject
	lobj.conductorlayer = layer
	set lobjs = app.Utility.NewLayerObjects
	lobjs.add(lobj)

	x = dx
	y = dy
	
	minx = x - d
	miny = y - d
	maxx = x + d
	maxy = y + d
	
	set objs = doc.Pick(minx, miny, maxx, maxy, 2, lobjs, true, True, 0)'gets trace objects
	for each obj in objs
		if obj.type2 = 20 then
			set trace = obj
			set geom = trace.geometry
			Call app.Gui.StatusBarText("trace width is " & geom.linewidth(0), 1)
		end if
	next
	
	
	
	set objs = doc.Pick(minx, miny, maxx, maxy, 1, lobjs, true, True, 0)'gets padstack objects
	for each obj in objs
		if obj.type = 1	then
			'it's a pin
			set pin = obj
			pin.selected = true
				set nets = doc.nets(1)
				for each net in nets
					net_name = net.name
				next
			pin.selected = false

			if pin.net.name = net_name then
				px = pin.positionx
				py = pin.positiony
				r = cdbl(pin.orientation) * (-1)
				
				set pads = pin.pads
				for each pad in pads
					set geoms = pad.geometries
					for each geom in geoms
					
						if geom.iscircle then
							w = pin.extrema.maxx - pin.extrema.minx
						else
							ptary = geom.PointsArray
							'translate pointsarray to 0,0
							for n = 0 to ubound(ptary, 2)
								ptary(0, n) = ptary(0, n) - px
								ptary(1, n) = ptary(1, n) - py
							next
							
							
							'translate mouse location to 0,0 with respect to the pin location
							x = x - px
							y = y - py
							
							'rotate the pointsarray by the pin orientation
							for n = 0 to ubound(ptary, 2)
								x1 = ptary(0, n)
								y1 = ptary(1, n)
								ptary(0, n) = get_rotated_x_coordinate(x1, y1, r)
								ptary(1, n) = get_rotated_y_coordinate(x1, y1, r)
							next
							
							'rotate x,y by the pin orientation
							x1 = x
							y1 = y
							x = get_rotated_x_coordinate(x1, y1, r)
							y = get_rotated_y_coordinate(x1, y1, r)
							
							'get min/max of pointsarray
							minx = 0
							miny = 0
							maxx = 0
							maxy = 0
							for n = 0 to ubound(ptary, 2)
								if ptary(0, n) < minx then minx = ptary(0, n)
								if ptary(0, n) > maxx then maxx = ptary(0, n)
								if ptary(1, n) < miny then miny = ptary(1, n)
								if ptary(1, n) > maxy then maxy = ptary(1, n)
							next
							
							pdx = maxx - minx
							pdy = maxy - miny
							
							if abs(x) > abs(y) then
								w = pdy
							else
								w = pdx
							end if
						end if
					next
				next
				
				pin.selected = true
				gui.processcommand("plow")
				gui.ProcessKeyin("cw " & w)
			end if
			
		end if
		
		if obj.type = 2 then
			'it's a via
			set via = obj
			set via_conns = via.connectedobjects
			for each via_conn in via_conns
				on error resume next
				if via_conn.type2 = 20 then
					'it's a trace
					set trace = via_conn
					if not trace.layer = layer then
						w = trace.geometry.linewidth
						via.selected = true
						gui.processcommand("plow")
						gui.ProcessKeyin("cw " & w)
					end if
				end if
			next
		end if
	next
	gui.TerminateCommand
	Set app = Nothing
	Set doc = Nothing
	
End Function


Public Function get_rotated_x_coordinate(x, y, r)
	Dim x1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	x1 = (x * Cos(r1)) - (y * Sin(r1))
	
	get_rotated_x_coordinate = x1
End Function

Public Function get_rotated_y_coordinate(x, y, r)
	Dim y1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	y1 = (x * Sin(r1)) + (y * Cos(r1))
	
	get_rotated_y_coordinate = y1
End Function


Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
