Option explicit

dim app
dim doc
dim gui
dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)
set gui = app.gui

run

Sub run()
	dim d
	dim min
	dim px, py, pdx, pdy, x, y, w, r, x1, y1
	dim minx, miny, maxx, maxy
	dim pin
	dim pins
	dim objs, obj
	dim comp
	dim cx, cy
	dim layer
	dim pads
	dim pad
	dim geom
	dim geoms
	dim ptary
	dim n
	dim via_conn
	dim via_conns
	dim vias
	dim via
	dim trace
	dim traces

	If not doc is nothing then
			
			w = 0
			
			'set pstks = doc.PadstackObjects(1,1)
			set pins = doc.pins(1)
			
			For Each pin In pins
					px = pin.positionx
					py = pin.positiony
					r = cdbl(pin.orientation) * (-1)
					
				set pads = pin.Pads
				For Each pad In pads
					set geoms = pad.geometries
						for each geom in geoms
							ptary = geom.PointsArray
						next
						
						'translate pointsarray to 0,0
						for n = 0 to ubound(ptary, 2)
							ptary(0, n) = ptary(0, n) - px
							ptary(1, n) = ptary(1, n) - py
						next
						
						'rotate the pointsarray by the pin orientation
						for n = 0 to ubound(ptary, 2)
							x1 = ptary(0, n)
							y1 = ptary(1, n)
							ptary(0, n) = get_rotated_x_coordinate(x1, y1, r)
							ptary(1, n) = get_rotated_y_coordinate(x1, y1, r)
						next
						
						'get min/max of pointsarray
						minx = 0
						miny = 0
						maxx = 0
						maxy = 0
						for n = 0 to ubound(ptary, 2)
							if ptary(0, n) < minx then minx = ptary(0, n)
							if ptary(0, n) > maxx then maxx = ptary(0, n)
							if ptary(1, n) < miny then miny = ptary(1, n)
							if ptary(1, n) > maxy then maxy = ptary(1, n)
						next
						
						pdx = maxx - minx
						pdy = maxy - miny
						
						if abs(x) > abs(y) then
							w = pdy
						else
							w = pdx
						end if
				Next
			Next
			
			if not w = 0 then
				set traces = doc.Traces(1)
				if doc.transactionstart(0) = true then
					For Each trace In traces
						trace.Geometry.LineWidth = w
					Next
					doc.transactionend(true)
				end if

			end if
			
			set vias = doc.vias(1)
			for each via in vias
				maxx = via.extrema.maxx
				minx = via.extrema.minx
				w = maxx - minx
				set traces = doc.Traces(1)
				if doc.transactionstart(0) = true then
					For Each trace In traces
						trace.Geometry.LineWidth = w
					Next
					doc.transactionend(true)
				end if
			next
			
			
			
	End if

End Sub


Set app = Nothing
Set doc = Nothing


Public Function get_rotated_x_coordinate(x, y, r)
	Dim x1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	x1 = (x * Cos(r1)) - (y * Sin(r1))
	
	get_rotated_x_coordinate = x1
End Function

Public Function get_rotated_y_coordinate(x, y, r)
	Dim y1
	Dim r1
	dim pi
	pi = 4 * Atn(1)
	
	'convert degrees to radians
	r1 = (r * pi) / 180
	
	y1 = (x * Sin(r1)) + (y * Cos(r1))
	
	get_rotated_y_coordinate = y1
End Function

Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
