Option explicit

dim app
dim doc
dim gui
dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)
set gui = app.gui

run


Sub run

	msgbox "in Swap Traces"
	If not doc is nothing then

			dim traces
			dim trace
			dim ptary1
			dim ptary2
			dim n
			dim geom1
			dim geom2
			dim w1
			dim w2
			dim net1
			dim net2
			dim layer
			dim pts1
			dim pts2
			
			set traces = doc.traces(1)
			if not traces.count = 2 then
				exit sub
			end if
			
			n = 0
			for each trace in traces
				if n = 0 then
					net1 = trace.net
					set geom1 = trace.geometry
					ptary1 = geom1.pointsarray
					pts1 = ubound(ptary1, 2) + 1
					w1 = geom1.linewidth
					layer = trace.layer
					trace.delete()
				end if
				if n = 1 then
					net2 = trace.net
					set geom2 = trace.geometry
					ptary2 = geom2.pointsarray
					pts2 = ubound(ptary2, 2) + 1
					w2 = geom2.linewidth
					trace.delete()
				end if
				n = n + 1
			next
			
			
			If doc.TransactionStart(0) = True Then
				'put trace1 with net2
				doc.puttrace layer, net2, w1, pts1, ptary1, nothing, 0, doc.currentunit
				
				'put trace1 with net2
				doc.puttrace layer, net1, w2, pts2, ptary2, nothing, 0, doc.currentunit
				
				doc.TransactionEnd(True)
			End If




	End if


End Sub


Set app = Nothing
Set doc = Nothing


Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub



Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
