Option explicit

dim app
dim doc
dim gui
dim prog_id
dim view
dim dsp

Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)
set gui = app.gui


If not doc is nothing then
	set view = doc.ActiveView
	set dsp = view.DisplayControl
	
	
	if not dsp is nothing Then
		if doc.transactionstart(0) = true then
			if dsp.Option("Option.Planes.Enabled") = 1 then
				dsp.Option("Option.Planes.Enabled") = 0
			else
				dsp.Option("Option.Planes.Enabled") = 1
			end if
			
			if dsp.Option("Option.Vias.Enable") = 1 then
				dsp.Option("Option.Vias.Enable") = 0
			else
				dsp.Option("Option.Vias.Enable") = 1
			end if
			
			if dsp.Option("Option.Pins.Enable") = 1 then
				dsp.Option("Option.Pins.Enable") = 0
			else
				dsp.Option("Option.Pins.Enable") = 1
			end if
			
			doc.transactioned(true)
		end if
	Else
		mgbox "No dsp"
	end If
	
	
End if

Set app = Nothing
Set doc = Nothing
set view = nothing
set dsp = nothing


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
