Option explicit

dim app
dim doc
dim gui
dim shell
dim regkey
dim local_app_data
dim idx
dim fso
dim file
dim tmp
dim ary
dim prog_id


'Hook to Expedition
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
'Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)

set gui = app.gui

If not doc is nothing then
	write_netlist
End if

Set app = Nothing
Set doc = Nothing


Sub write_netlist()

	dim net, nets
	dim part, parts
	dim comp, comps
	dim pin, pins
	dim str, ref
	dim list
	dim filesys
	dim ofile
	dim p1, p2
	dim ary()
	
	
	
	Set list = CreateObject("System.Collections.ArrayList")
	list.add "%net" & vbcrlf
	
	set nets = doc.nets(0)
	for each net in nets
		str = "\" & net.name & "\    "
		set pins = net.pins
		for each pin in pins
			set comp = pin.component
			ref = comp.refdes
			str = str & "\" & ref & "\-\" & pin.name & "\ "
		next
		list.add str
	next
	
	list.add vbcrlf & vbcrlf & "%Part" & vbcrlf
	
	set parts = doc.parts
	for each part in parts
		str = "\" & part.name & "\    "
		set comps = part.components
		for each comp in comps
			str = str & "\" & comp.refdes & "\ " 
		next
		list.add str
	next
	
	
	str = join(list.toarray(), vbcrlf)
	
	set filesys=CreateObject("Scripting.FileSystemObject")
	p1 = doc.Path & "LogFiles\KeyinNetList.txt"
	p2 = doc.Path & "Config\KeyinNetList_old.txt"
	Set ofile = filesys.CreateTextFile(p1,True)
	ofile.Write str
	ofile.Close
	
	Set ofile = filesys.CreateTextFile(p2,True)
	ofile.Write str
	ofile.Close
	

	
	
	
End Sub


'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function
