Option explicit


	
	
	dim app
	dim doc
	dim gui

	dim prog_id

	get_id()
	Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
	Set doc = GetLicensedDoc(app)
	set gui = app.gui
	
	run
	
Public Sub run
	dim pins
	dim pin
	dim planes
	dim plane
	dim cshape
	dim cshapes
	dim vias
	dim via
	dim traces
	dim trace
	dim net
	dim x, y, x1, y1, x2, y2, r
	dim geom
	dim ptary
	dim pts
	dim gfx
	dim layer
	dim n, i
	dim drc
	dim std
	dim via_path
	dim anchor
	
	msgbox "in change_plane_shape_net_to_selected_pin_net"
	
	
	via_path = false
	
	layer = gui.ActiveRouteLayer

	If not doc is nothing then
	
		std = gui.SuppressTrivialDialogs
		gui.SuppressTrivialDialogs = true
		drc = doc.editorcontrol.interactiveDRC
		doc.editorcontrol.interactiveDRC = false
		
		set pins = doc.pins(1)
		set planes = doc.planeshapes(1)
		set cshapes = doc.conductiveareas(1)
		set vias = doc.vias(1)
		set traces = doc.traces(1)
		
		if pins.count = 0 and vias.count = 0 then
			msgbox "No pins or vias selected"
			exit sub
		end if
		
		if pins.count = 0 and vias.count > 0 then
			via_path = true
		end if
		
		
		
		
		
		if doc.transactionstart(0) = true then
			if via_path = true then
			
				msgbox "via_path is true and planes.count is: " & planes.count
				
			
				for each via in vias
					net = via.net
				next
				
				if planes.count > 0 then
					msgbox "in planes.count"
					n = 0
					for each plane in planes
						msgbox "plane: " & n
						anchor = plane.anchor
						set plane.anchor = 0
						set plane.net = net
						set plane.anchor = anchor
						n+= 1
						msgbox "plane.net is: " & plane.net.name.tostring
					next
				end if
				
				if cshapes.count > 0 then
					for each cshape in cshapes
						set cshape.net = net
					next
				end if
			else
			
				msgbox "via_path is false"
				
				for each pin in pins
					set net = pin.net
					exit for
				next
				
				if planes.count > 0 then
					for each plane in planes
						set plane.net = net
					next
				end if
				
				if cshapes.count > 0 then
					for each cshape in cshapes
						set cshape.net = net
					next
				end if
				
				if vias.count > 0 then
					for each via in vias
						set via.net = net
					next
				end if
			end if

			
			doc.transactionend(true)
		
		end if
		
		
		set doc.editorcontrol.interactiveDRC = drc
		gui.SuppressTrivialDialogs = std
		
	End if
	
	


	Set app = Nothing
	Set doc = Nothing

End Sub

Sub change_trace_net()
	dim traces
	dim trace
	dim pins
	dim pin
	dim net
	dim vias
	dim via
	
	set traces = doc.traces(1)
	set pins = doc.pins(1)
	
	
	
	for each pin in pins
		net = pin.net
		exit for
	next
	
	for each trace in traces
		set trace.net = net
	next
	
	for each via in vias
		set via.net = net
	next
	
	
End Sub




Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub




'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function