Option explicit

dim app
dim doc
dim gui
dim shell
dim regkey
dim local_app_data
dim idx
dim fso
dim file
dim tmp
dim ref
dim ary
dim prog_id
dim sl




'get the value of prog_id from the registry
'regkey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\MGCPCB.ExpeditionPCBApplication\CurVer\"
'tmp = objShell.RegRead(regkey) 
'tmp = mid(tmp,InStrRev(tmp, ".") + 1)
'prog_id = tmp

get_id()

'Hook to Expedition
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
'Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication")
Set doc = GetLicensedDoc(app)

set gui = app.gui


If not doc is nothing then

		Dim comps
		Dim comp
		Dim a, x, x0, y, maxx, maxy, minx, miny, w, h, cx, cy, cx1, cy1
		Dim cu, n, r, c
		Dim pos
		Dim po
		Dim ext
		Dim part_clearance
		
		cu = doc.CurrentUnit
		doc.CurrentUnit = 2
		
		part_clearance = 20
		
		set comps = doc.Components(1, -1, 4)
		
		
		'get the number of rows and columns needed to house the clump
		'to do this, take the square root of the number of components, then add 1 to the integer portion of that number. 
		r = Int(comps.Count ^.5)
		r = r + 1
		
		'get the extents of the location of all the parts
		minx = 10000000000000000
		miny = 10000000000000000
		maxx = -10000000000000000
		maxy = -10000000000000000
		For Each comp In comps
			If comp.PositionX < minx Then minx = comp.PositionX
			If comp.PositionX > maxx Then maxx = comp.PositionX
			If comp.PositionY < miny Then miny = comp.PositionY
			If comp.PositionY > maxy Then maxy = comp.PositionY
		Next
		
		cx = (maxx + minx) / 2
		cy = (maxy + miny) / 2
		
		
		redim sl(comps.count - 1)
		
		'get the total area of the parts
		a = 0
		n = 0
		For Each comp In comps
			set pos = comp.PlacementOutlines
			For Each po In pos
				Exit For
			Next
			a = Int((po.Extrema.MaxX - po.Extrema.MinX) * (po.Extrema.MaxY - po.Extrema.MinY))
			'a = a + Int((po.Extrema.MaxX - po.Extrema.MinX) * (po.Extrema.MaxY - po.Extrema.MinY))
			sl(n) = a & " " & comp.refdes
			n  = n + 1
		Next
		
		sl = Sort(sl)
		
		tmp = ""
		for n = 0 to ubound(sl)
			tmp = tmp & sl(n) & vbcrlf
		next
		
		'msgbox tmp
		
		'now find the approximate middle of the part area, and move up and to the left to start placing parts 
		
		w = Int(a ^ .5)
		x = cx - Int(w / 2)
		y = cy + Int(w / 2)
		x0 = x
		
		'start by placing the first component in the upper left corner
		'get the part width/2 >> cx
		'for each successive part, get the part width/2 cx1
		'make x = old x plus cx + cx1 + gap (15 mils)
		'keep y the same
		'set miny to the y - the part height/2 if that is lower than the exising miny
		'set cx = cx1
		
		cx = 0
		cy = 0
		c = 0
		miny = y
		
		If doc.TransactionStart(0) = True Then
		
			for each tmp in sl
				ary = split(tmp, " ")
				ref = ary(1)
				set comp = doc.findcomponent(ref)
				if not comp is nothing then
					set pos = comp.PlacementOutlines
					For Each po In pos
						Exit For
					Next
					set ext = po.Extrema
					cx1 = (ext.MaxX - ext.MinX) / 2
					cy1 = (ext.MaxY - ext.MinY) / 2
					
					c = c + 1
					If c > r Then
						y = miny - part_clearance - cy1
						x = x0
						c = 1
						cx = 0
					End If
					
					If cx = 0 Then
						comp.Move x, y
						cx = cx1
					Else
						x = x + cx + cx1 + part_clearance
						comp.Move x, y
						cx = cx1
					End If
					
					If (y - cy1) < miny Then miny = y - cy1
				end if
			next
			

			doc.TransactionEnd(True)
		End If
		doc.CurrentUnit = cu



End if

Set app = Nothing
Set doc = Nothing

Public Function Sort( ByRef arrSample )
	Dim i, j, strHolder
	dim a1, a2
	dim k, l
	dim intNumber
	dim TempValue
	
	
	tmp =  "array before"
	For Each intNumber In arrSample
	  tmp = tmp & intNumber & vbcrlf
	Next
	For i = LBound(arrSample) to UBound(arrSample)
	  For j = LBound(arrSample) to UBound(arrSample)
		If j <> UBound(arrSample) Then
			a1 = split(arrSample(j), " ")
			k = cdbl(a1(0))
			
			a2 = split(arrSample(j + 1), " ")
			l = cdbl(a2(0))
		  If k < l Then
			 TempValue = arrSample(j + 1)
			 arrSample(j + 1) = arrSample(j)
			 arrSample(j) = TempValue
		  End If
		End If
	  Next
	Next
	tmp = tmp &  vbCrLf & "array after"
	For Each intNumber In arrSample
	  tmp = tmp & intNumber & vbcrlf
	Next
	
	'msgbox tmp
	

	' For i = 0 to ubound(myArray)
		' a1 = split(myArray(i), " ")
		' k = a1(0)
		
		' For j= k + 1 to ubound(myArray)
			
			' a2 = split(myArray(j), " ")
			' l = a2(0)
			
			' If k > l Then
				' strHolder = myArray(i)
				' myArray(i) = myArray(j)
				' myArray(j) = strHolder
			' End If
		' Next
	' Next 
	
	Sort = arrSample
End Function




Public Sub get_id()
	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function