Option explicit



	dim app
	dim doc
	dim gui

	dim prog_id

	get_id()
	Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
	Set doc = GetLicensedDoc(app)
	set gui = app.gui
	
	run
	
Public Sub run
	dim pins
	dim pin
	dim vias
	dim via
	dim traces
	dim trace
	dim net
	dim x, y, x1, y1, x2, y2, r
	dim geom
	dim ptary
	dim pts
	dim gfx
	dim layer
	dim n, i
	
	
	
	layer = gui.ActiveRouteLayer

	If not doc is nothing then
		
		set vias = doc.vias(1)
		set pins = doc.pins(1)
		set traces = doc.traces(1)

		
		if vias.count = 0 and pins.count = 0 and traces.count = 0 then
		
			msgbox "No vias, pins, or traces selected"
			exit sub
		
		else
		
			for each via in vias
				set net = via.net
				
				x1 = via.extrema.minx
				x = via.positionx
				y = via.positiony
				r = (x - x1) / 2
				
				exit for
			next
			
			for each pin in pins
				set net = pin.net
				x1 = pin.extrema.minx
				x = pin.positionx
				y = pin.positiony
				r = (x - x1) / 2
				exit for
				
			next
			
			'for each trace in traces
			'	set net = trace.net
			'	set geom = trace.geometry
			'	set ptary = geom.pointsarray
			'	x = ptary(0,0)
			'	y = ptary(0,1)
			'	r = geom.linewidth / 2
			'	exit for
			'next
			
			x1 = x - r
			y1 = y - r
			x2 = x + r
			y2 = y + r
			
			redim ptary(2,4)
			
			ptary(0, 0) = x1
			ptary(1, 0) = y1
			ptary(2, 0) = 0
			ptary(0, 1) = x1
			ptary(1, 1) = y2
			ptary(2, 1) = 0
			ptary(0, 2) = x2
			ptary(1, 2) = y2
			ptary(2, 2) = 0
			ptary(0, 3) = x2
			ptary(1, 3) = y1
			ptary(2, 3) = 0
			ptary(0, 4) = x1
			ptary(1, 4) = y1
			ptary(2, 4) = 0
			
			pts = 5
			
			set gfx = doc.putplaneshape(layer, pts, ptary, net, false, , , , nothing, 0)
			gfx.selected = true
			
		end if
		
		gui.activemode = 2
		gui.processcommand("Edit->Place->Plane Shape")
		
		
		if not gfx is nothing then
			gfx.delete
		end if
		
	End if

	'msgbox tmp

	Set app = Nothing
	Set doc = Nothing

End Sub




Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub




'-------------------------------------------------------------------------
' Function that returns a licensed doc object
'
' Returns: 
'   - 'Nothing' if licensing failed . 
'   - A reference to the active document of the application if 
'     licensing succeeded. 
'-------------------------------------------------------------------------
Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function