Option explicit

dim app
dim doc
dim gui
dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
Set doc = GetLicensedDoc(app)
set gui = app.gui

run

Sub run()
	dim dsp
	dim view
	dim f
	dim fs
	dim path
	dim n
	dim file_text
	dim ary
	dim name, name1, name2
	dim std

	std = gui.SuppressTrivialDialogs

	If not doc is nothing then

		'get path to the setup file
		path = doc.fullname
		n = instrrev(path, "\")
		
		path = left(path, n) & "Config\set_dc_schemes_1_and_2.txt"
		
		Set fs = CreateObject("Scripting.FileSystemObject")
		if fs.FileExists(path) then
			'read the file and get the data from it
			set f = fs.OpenTextFile(path, 1)
			file_text = f.readline
			f.close
			ary = split(file_text, vbtab)
			name1 = ary(1)
		Else
			'if the setup file doesn't exist, ask for scheme names and create file
			name1 = inputbox("What is the name of the first scheme?")
			name2 = inputbox("What is the name of the second scheme?")
			name = name1 & vbtab & name2
			Set f = fs.OpenTextFile(path, 2, True)
			f.Write(name)
			f.Close
		End If
		
		set view = doc.ActiveView
		set dsp = view.DisplayControl
		
		on error resume next
		
		gui.SuppressTrivialDialogs = true
		
		dsp.LoadScheme("Loc:" & name1)
		
		if err.number <> 0 then
			err.clear
			dsp.LoadScheme("Sys:" & name1)
			if err.number <> 0 then
				msgbox name1  & " does not exist"
			end if 
		else
		
		end if 
		
		gui.SuppressTrivialDialogs = std
		

	End if

End Sub

Set app = Nothing
Set doc = Nothing


Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function