Option explicit

dim app
dim doc
dim gui
dim prog_id

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
Set doc = GetLicensedDoc(app)
set gui = app.gui

run


Sub run
	If not doc is nothing then

			Dim comps
			Dim comp, c1, c2
			Dim x1, y1, x2, y2, r1, r2
			Dim n, s1, s2

			set comps = doc.Components(1)

			n = 1
			For Each comp In comps
				If n = 1 Then
					set c1 = comp
					x1 = comp.PositionX
					y1 = comp.PositionY
					r1 = comp.Orientation
					s1 = comp.Side
				Else
					set c2 = comp
					x2 = comp.PositionX
					y2 = comp.PositionY
					r2 = comp.Orientation
					s2 = comp.Side
				End If
				n = n + 1
			Next

			If doc.TransactionStart(0) = True Then

				If s2 = 1 Then
					c1.Place x2, y2, r2, True
				Else
					c1.Place x2, y2, r2, False
				End If

				If s1 = 1 Then
					c2.Place x1, y1, r1, True
				Else
					c2.Place x1, y1, r1, False
				End If
				doc.TransactionEnd(True)
			End If




	End if


End Sub


Set app = Nothing
Set doc = Nothing


Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub



Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function