Option explicit

dim app
dim doc
dim gui
dim prog_id
dim view
dim dsp

get_id()
Set app = GetObject(, "MGCPCB.ExpeditionPCBApplication" & "." & prog_id)
Set doc = GetLicensedDoc(app)
set gui = app.gui

If not doc is nothing then
	set view = doc.ActiveView
	set dsp = view.DisplayControl
	
	if dsp.Option("Option.Pins.Enable") = 1 then
		dsp.Option("Option.Pins.Enable") = 0
	else
		dsp.Option("Option.Pins.Enable") = 1
	end if
End if

Set app = Nothing
Set doc = Nothing
set view = nothing
set dsp = nothing

Public Sub get_id()
	dim shell
	dim local_app_data
	dim idx
	dim fso
	dim file
	dim tmp
	dim ary

	Set shell = CreateObject( "WScript.Shell" )
	'get appdata path
	local_app_data = shell.ExpandEnvironmentStrings("%APPDATA%")

	're-route appdata path to local\ExactCAD
	idx = instr(local_app_data, "AppData")

	'add the Selected_Version filename
	local_app_data = Left(local_app_data, idx + 6) & "\Local\ExactCAD\Selected_Version.txt"


	'create file system object
	Set fso = CreateObject("Scripting.FileSystemObject")

	'see if the file exists
	If (fso.FileExists(local_app_data)) Then
		'if so, open the file
		set file = fso.OpenTextFile(local_app_data)
		
		'read each line of the file
		Do until file.AtEndOfStream
			tmp = file.ReadLine
			
			'look for maglaunch_path in each line of the file
			if instr(tmp, vbtab) > 0 then
				
				'when found, split the string into an array using the tab delimiter
				ary = split(tmp, vbtab)
				
				if ary(0) = "id" then
					prog_id = ary(1)
				end if

			end if
		Loop
		
		'close the file
		file.Close
		
	End If

	'terminate the shell
	set shell = Nothing



End Sub


Public Function GetLicensedDoc(appObj)
    On Error Resume next
    Dim key,licenseServer,licenseToken,docObj

    Set GetLicensedDoc = Nothing

    ' collect the active document
    Set docObj = appObj.ActiveDocument
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document: " + _
                                 Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' Ask Expeditions document for the key
    key = docObj.Validate(0)

    ' Get token from license server
    Set licenseServer = CreateObject("MGCPCBAutomationLicensing.Application")
    licenseToken = licenseServer.GetToken(key)
    Set licenseServer = Nothing

    ' Ask the document to validate the license token
    Err.Clear 
    docObj.Validate(licenseToken)
    If (Err) Then  
        Call appObj.Gui.StatusBarText("No active document license: " + _
                                      Err.Description,epcbStatusFieldError)
        Exit Function
    End If

    ' everything is OK, return document
    Set GetLicensedDoc = docObj 
End Function